; 
    include \masm32\include\masm32rt.inc
    include \masm32\include\ddraw.inc
    includelib \masm32\lib\ddraw.lib

    DD_OK EQU 0

    DDO_GetScanLine EQU 64
    
    DDERR_INVALIDPARAMS EQU E_INVALIDARG
    DDERR_UNSUPPORTED   EQU E_NOTIMPL
    DDERR_INVALIDOBJECT EQU ((1 shl 31) or (876h shl 16) or ( 130 ))
    DDERR_VERTICALBLANKINPROGRESS EQU ((1 shl 31)or(876h shl 16)or(537))

    DDGetScanLine PROTO scanLine:DWORD
    WaitForVerticalBlank PROTO
; 
    .data
        lpdd_1    dd          0
        hInst     dd          0
        hWnd      dd          0
        vSync     dd          0
        wc        WNDCLASSEX  <>
        msg       MSG         <>
        rect      RECT        <>
        className db          "vsynctestclass",0
        
    .code
; 
start:
; 
    ; ------------------------------------
    ; Create a default DirectDraw object.
    ; ------------------------------------
    invoke DirectDrawCreate,NULL,ADDR lpdd_1,NULL
    .IF eax
        MsgBox 0,"DirectDrawCreate failed",0,0
    .ENDIF

    mov   hInst, rv(GetModuleHandle, NULL)
    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInst
    mov   wc.hbrBackground, COLOR_WINDOW+1
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         NULL
    mov   wc.hCursor,       NULL
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("VSync Test"),
                            WS_OVERLAPPEDWINDOW,
                            0,0,600,400,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax

    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd
  msgLoop:
    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF (eax != 0)
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp   msgLoop
    .ENDIF
    exit msg.wParam

; 

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    LOCAL hDC:HDC 
    LOCAL ps:PAINTSTRUCT
    
    .IF uMsg==WM_CREATE
      invoke SetTimer,hWin,1,10,NULL
    .ELSEIF uMsg==WM_TIMER
      .IF wParam==1
        .IF vSync
          invoke WaitForVerticalBlank
        .ENDIF  
        invoke InvalidateRect,hWin,NULL,TRUE
      .ENDIF
    .ELSEIF uMsg==WM_LBUTTONDOWN
      not   vSync       
    .ELSEIF uMsg==WM_DESTROY
      invoke KillTimer,hWin,1
      invoke PostQuitMessage,NULL
    .ELSEIF uMsg==WM_PAINT
      invoke BeginPaint,hWin,ADDR ps
      mov   hDC,eax
      .IF vSync
        invoke TextOut,hDC,5,5,chr$("CLICK CLIENT AREA TO TOGGLE VSYNC OFF"),37
      .ELSE
        invoke TextOut,hDC,5,5,chr$("CLICK CLIENT AREA TO TOGGLE VSYNC ON"),36
      .ENDIF
      invoke EndPaint,hWin,ADDR ps
    .ELSE 
      invoke DefWindowProc,hWin,uMsg,wParam,lParam
      ret 
    .ENDIF
    xor    eax,eax
    ret
WndProc endp

; 

DDGetScanLine proc lpScanLine:DWORD

    push  lpScanLine
    push  lpdd_1
    mov   eax, lpdd_1
    mov   eax, [eax]
    call  DWORD PTR[eax+DDO_GetScanLine]
    ret

DDGetScanLine endp

; 

WaitForVerticalBlank proc

    LOCAL localScanLine:DWORD

    invoke DDGetScanLine, ADDR localScanLine
    ; -------------------------------
    ; Wait until not vertical blank.
    ; -------------------------------
    .WHILE (eax == DDERR_VERTICALBLANKINPROGRESS)
        invoke DDGetScanLine, ADDR localScanLine
    .ENDW
    ; ---------------------------
    ; Wait until vertical blank.
    ; ---------------------------
    .WHILE (eax != DDERR_VERTICALBLANKINPROGRESS)
        invoke DDGetScanLine, ADDR localScanLine
    .ENDW

    ret

WaitForVerticalBlank endp

; 

end start
